Index: uspace/lib/ui/src/list.c
===================================================================
--- uspace/lib/ui/src/list.c	(revision 56a3c29e88b204aab857b6e159ccf9e553cf0c09)
+++ uspace/lib/ui/src/list.c	(revision 4f6368c9f43c5e184ce86a446688b4311b0d63f1)
@@ -800,4 +800,26 @@
 }
 
+/** Change list entry caption.
+ *
+ * @param entry UI list entry
+ * @param caption New caption
+ *
+ * @return EOK on success, ENOMEM if out of memory
+ */
+errno_t ui_list_entry_set_caption(ui_list_entry_t *entry, const char *caption)
+{
+	char *dcaption;
+
+	dcaption = str_dup(caption);
+	if (dcaption == NULL)
+		return ENOMEM;
+
+	free(entry->caption);
+	entry->caption = dcaption;
+
+	(void)ui_list_entry_paint(entry, ui_list_entry_get_idx(entry));
+	return EOK;
+}
+
 /** Clear UI list entry list.
  *
Index: uspace/lib/ui/src/resource.c
===================================================================
--- uspace/lib/ui/src/resource.c	(revision 56a3c29e88b204aab857b6e159ccf9e553cf0c09)
+++ uspace/lib/ui/src/resource.c	(revision 4f6368c9f43c5e184ce86a446688b4311b0d63f1)
@@ -86,6 +86,6 @@
 	gfx_color_t *entry_sel_text_fg_color = NULL;
 	gfx_color_t *entry_sel_text_bg_color = NULL;
-	gfx_color_t *sbar_through_color = NULL;
-	gfx_color_t *sbar_act_through_color = NULL;
+	gfx_color_t *sbar_trough_color = NULL;
+	gfx_color_t *sbar_act_trough_color = NULL;
 	errno_t rc;
 
@@ -221,10 +221,10 @@
 
 	rc = gfx_color_new_rgb_i16(0xe4e4, 0xe4e4, 0xe4e4,
-	    &sbar_through_color);
+	    &sbar_trough_color);
 	if (rc != EOK)
 		goto error;
 
 	rc = gfx_color_new_rgb_i16(0x5858, 0x5858, 0x5858,
-	    &sbar_act_through_color);
+	    &sbar_act_trough_color);
 	if (rc != EOK)
 		goto error;
@@ -265,6 +265,6 @@
 	resource->entry_sel_text_bg_color = entry_sel_text_bg_color;
 
-	resource->sbar_through_color = sbar_through_color;
-	resource->sbar_act_through_color = sbar_act_through_color;
+	resource->sbar_trough_color = sbar_trough_color;
+	resource->sbar_act_trough_color = sbar_act_trough_color;
 
 	*rresource = resource;
@@ -327,8 +327,8 @@
 		gfx_color_delete(entry_act_bg_color);
 
-	if (sbar_through_color != NULL)
-		gfx_color_delete(sbar_through_color);
-	if (sbar_act_through_color != NULL)
-		gfx_color_delete(sbar_act_through_color);
+	if (sbar_trough_color != NULL)
+		gfx_color_delete(sbar_trough_color);
+	if (sbar_act_trough_color != NULL)
+		gfx_color_delete(sbar_act_trough_color);
 
 	if (tface != NULL)
@@ -376,6 +376,6 @@
 	gfx_color_t *entry_sel_text_bg_color = NULL;
 	gfx_color_t *entry_act_bg_color = NULL;
-	gfx_color_t *sbar_through_color = NULL;
-	gfx_color_t *sbar_act_through_color = NULL;
+	gfx_color_t *sbar_trough_color = NULL;
+	gfx_color_t *sbar_act_trough_color = NULL;
 	errno_t rc;
 
@@ -497,9 +497,9 @@
 		goto error;
 
-	rc = gfx_color_new_ega(0x07, &sbar_through_color);
-	if (rc != EOK)
-		goto error;
-
-	rc = gfx_color_new_ega(0x07, &sbar_act_through_color);
+	rc = gfx_color_new_ega(0x07, &sbar_trough_color);
+	if (rc != EOK)
+		goto error;
+
+	rc = gfx_color_new_ega(0x07, &sbar_act_trough_color);
 	if (rc != EOK)
 		goto error;
@@ -540,6 +540,6 @@
 	resource->entry_sel_text_bg_color = entry_sel_text_bg_color;
 
-	resource->sbar_through_color = sbar_through_color;
-	resource->sbar_act_through_color = sbar_act_through_color;
+	resource->sbar_trough_color = sbar_trough_color;
+	resource->sbar_act_trough_color = sbar_act_trough_color;
 
 	*rresource = resource;
@@ -601,8 +601,8 @@
 	if (entry_sel_text_bg_color != NULL)
 		gfx_color_delete(entry_sel_text_bg_color);
-	if (sbar_through_color != NULL)
-		gfx_color_delete(sbar_through_color);
-	if (sbar_act_through_color != NULL)
-		gfx_color_delete(sbar_act_through_color);
+	if (sbar_trough_color != NULL)
+		gfx_color_delete(sbar_trough_color);
+	if (sbar_act_trough_color != NULL)
+		gfx_color_delete(sbar_act_trough_color);
 
 	if (tface != NULL)
@@ -665,6 +665,6 @@
 	gfx_color_delete(resource->entry_sel_text_bg_color);
 
-	gfx_color_delete(resource->sbar_through_color);
-	gfx_color_delete(resource->sbar_act_through_color);
+	gfx_color_delete(resource->sbar_trough_color);
+	gfx_color_delete(resource->sbar_act_trough_color);
 
 	gfx_font_close(resource->font);
Index: uspace/lib/ui/src/scrollbar.c
===================================================================
--- uspace/lib/ui/src/scrollbar.c	(revision 56a3c29e88b204aab857b6e159ccf9e553cf0c09)
+++ uspace/lib/ui/src/scrollbar.c	(revision 4f6368c9f43c5e184ce86a446688b4311b0d63f1)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2022 Jiri Svoboda
+ * Copyright (c) 2023 Jiri Svoboda
  * All rights reserved.
  *
@@ -35,13 +35,13 @@
  * Anatomy of a horizontal scrollbar:
  *
- *       Up                Down
- *      through           through
- * +---+------+--------+---------+---+
- * | < |      |   |||  |         | > |
- * +---+------+--------+---------+---+
- *  Up           Thumb           Down
- * button                       button
- *
- *     +-------- Through --------+
+ *        Upper             Lower
+ *       trough            trough
+ *  +---+------+--------+---------+---+
+ *  | < |      |   |||  |         | > |
+ *  +---+------+--------+---------+---+
+ *   Up           Thumb           Down
+ * button                        button
+ *
+ *     +-------- Trough --------+
  *
  * Scrollbar uses the same terminology whether it is running in horizontal
@@ -51,8 +51,8 @@
  * The thumb can be dragged to a specific position, resulting in a move
  * event. The up/down buttons generate up/down events. Pressing a mouse
- * button on the up/down through generates page up / page down events.
- *
- * Pressing and holding down mouse button on up / down button or up / down
- * through will auto-scroll (using clickmatic).
+ * button on the upper/lower trough generates page up / page down events.
+ *
+ * Pressing and holding down mouse button on up / down button or upper /
+ * lower trough will auto-scroll (using clickmatic).
  */
 
@@ -360,5 +360,5 @@
 }
 
-/** Determine scrollbar through length.
+/** Determine scrollbar trough length.
  *
  * Return the size of the space within which the thumb can move
@@ -366,7 +366,7 @@
  *
  * @param scrollbar Scrollbar
- * @return Scrollbar through length in pixels
- */
-gfx_coord_t ui_scrollbar_through_length(ui_scrollbar_t *scrollbar)
+ * @return Scrollbar trough length in pixels
+ */
+gfx_coord_t ui_scrollbar_trough_length(ui_scrollbar_t *scrollbar)
 {
 	ui_resource_t *resource;
@@ -396,5 +396,5 @@
 gfx_coord_t ui_scrollbar_move_length(ui_scrollbar_t *scrollbar)
 {
-	return ui_scrollbar_through_length(scrollbar) -
+	return ui_scrollbar_trough_length(scrollbar) -
 	    scrollbar->thumb_len;
 }
@@ -417,5 +417,5 @@
 	    ui_scrollbar_min_thumb_len;
 
-	max_len = ui_scrollbar_through_length(scrollbar);
+	max_len = ui_scrollbar_trough_length(scrollbar);
 	if (len < min_len)
 		len = min_len;
@@ -459,5 +459,5 @@
 		scrollbar->pos = pos;
 		(void) ui_scrollbar_paint(scrollbar);
-		ui_scrollbar_throughs_update(scrollbar,
+		ui_scrollbar_troughs_update(scrollbar,
 		    &scrollbar->last_curs_pos);
 	}
@@ -487,26 +487,26 @@
 		goto error;
 
-	/* Paint scrollbar up through */
+	/* Paint scrollbar upper trough */
 	rc = gfx_set_color(resource->gc,
-	    scrollbar->up_through_held && scrollbar->up_through_inside ?
-	    resource->sbar_act_through_color :
-	    resource->sbar_through_color);
-	if (rc != EOK)
-		goto error;
-
-	rc = gfx_fill_rect(resource->gc, &geom.up_through_rect);
-	if (rc != EOK)
-		goto error;
-
-	/* Paint scrollbar down through */
+	    scrollbar->upper_trough_held && scrollbar->upper_trough_inside ?
+	    resource->sbar_act_trough_color :
+	    resource->sbar_trough_color);
+	if (rc != EOK)
+		goto error;
+
+	rc = gfx_fill_rect(resource->gc, &geom.upper_trough_rect);
+	if (rc != EOK)
+		goto error;
+
+	/* Paint scrollbar lower trough */
 
 	rc = gfx_set_color(resource->gc,
-	    scrollbar->down_through_held && scrollbar->down_through_inside ?
-	    resource->sbar_act_through_color :
-	    resource->sbar_through_color);
-	if (rc != EOK)
-		goto error;
-
-	rc = gfx_fill_rect(resource->gc, &geom.down_through_rect);
+	    scrollbar->lower_trough_held && scrollbar->lower_trough_inside ?
+	    resource->sbar_act_trough_color :
+	    resource->sbar_trough_color);
+	if (rc != EOK)
+		goto error;
+
+	rc = gfx_fill_rect(resource->gc, &geom.lower_trough_rect);
 	if (rc != EOK)
 		goto error;
@@ -561,8 +561,8 @@
 	ui_scrollbar_get_geom(scrollbar, &geom);
 
-	/* Paint scrollbar through */
-
-	rc = ui_paint_text_rect(resource, &geom.through_rect,
-	    resource->sbar_through_color, "\u2592");
+	/* Paint scrollbar trough */
+
+	rc = ui_paint_text_rect(resource, &geom.trough_rect,
+	    resource->sbar_trough_color, "\u2592");
 	if (rc != EOK)
 		goto error;
@@ -571,5 +571,5 @@
 
 	rc = ui_paint_text_rect(resource, &geom.thumb_rect,
-	    resource->sbar_through_color, "\u25a0");
+	    resource->sbar_trough_color, "\u25a0");
 	if (rc != EOK)
 		goto error;
@@ -647,9 +647,9 @@
 		geom->up_btn_rect.p1.y = orect.p1.y;
 
-		/* Through */
-		geom->through_rect.p0.x = geom->up_btn_rect.p1.x;
-		geom->through_rect.p0.y = irect.p0.y;
-		geom->through_rect.p1.x = orect.p1.x - btn_len;
-		geom->through_rect.p1.y = irect.p1.y;
+		/* Trough */
+		geom->trough_rect.p0.x = geom->up_btn_rect.p1.x;
+		geom->trough_rect.p0.y = irect.p0.y;
+		geom->trough_rect.p1.x = orect.p1.x - btn_len;
+		geom->trough_rect.p1.y = irect.p1.y;
 
 		/* Thumb */
@@ -661,16 +661,16 @@
 		geom->thumb_rect.p1.y = orect.p1.y;
 
-		/* Up through */
-		geom->up_through_rect.p0 = geom->through_rect.p0;
-		geom->up_through_rect.p1.x = geom->thumb_rect.p0.x;
-		geom->up_through_rect.p1.y = geom->through_rect.p1.y;
-
-		/* Down through */
-		geom->down_through_rect.p0.x = geom->thumb_rect.p1.x;
-		geom->down_through_rect.p0.y = geom->through_rect.p0.y;
-		geom->down_through_rect.p1 = geom->through_rect.p1;
+		/* Upper trough */
+		geom->upper_trough_rect.p0 = geom->trough_rect.p0;
+		geom->upper_trough_rect.p1.x = geom->thumb_rect.p0.x;
+		geom->upper_trough_rect.p1.y = geom->trough_rect.p1.y;
+
+		/* Lower trough */
+		geom->lower_trough_rect.p0.x = geom->thumb_rect.p1.x;
+		geom->lower_trough_rect.p0.y = geom->trough_rect.p0.y;
+		geom->lower_trough_rect.p1 = geom->trough_rect.p1;
 
 		/* Down button */
-		geom->down_btn_rect.p0.x = geom->through_rect.p1.x;
+		geom->down_btn_rect.p0.x = geom->trough_rect.p1.x;
 		geom->down_btn_rect.p0.y = orect.p0.y;
 		geom->down_btn_rect.p1.x = orect.p1.x;
@@ -683,9 +683,9 @@
 		geom->up_btn_rect.p1.y = orect.p0.y + btn_len;
 
-		/* Through */
-		geom->through_rect.p0.x = irect.p0.x;
-		geom->through_rect.p0.y = geom->up_btn_rect.p1.y;
-		geom->through_rect.p1.x = irect.p1.x;
-		geom->through_rect.p1.y = orect.p1.y - btn_len;
+		/* Trough */
+		geom->trough_rect.p0.x = irect.p0.x;
+		geom->trough_rect.p0.y = geom->up_btn_rect.p1.y;
+		geom->trough_rect.p1.x = irect.p1.x;
+		geom->trough_rect.p1.y = orect.p1.y - btn_len;
 
 		/* Thumb */
@@ -697,17 +697,17 @@
 		    scrollbar->thumb_len;
 
-		/* Up through */
-		geom->up_through_rect.p0 = geom->through_rect.p0;
-		geom->up_through_rect.p1.x = geom->through_rect.p1.x;
-		geom->up_through_rect.p1.y = geom->thumb_rect.p0.y;
-
-		/* Down through */
-		geom->down_through_rect.p0.x = geom->through_rect.p0.x;
-		geom->down_through_rect.p0.y = geom->thumb_rect.p1.y;
-		geom->down_through_rect.p1 = geom->through_rect.p1;
+		/* Upper trough */
+		geom->upper_trough_rect.p0 = geom->trough_rect.p0;
+		geom->upper_trough_rect.p1.x = geom->trough_rect.p1.x;
+		geom->upper_trough_rect.p1.y = geom->thumb_rect.p0.y;
+
+		/* Lower trough */
+		geom->lower_trough_rect.p0.x = geom->trough_rect.p0.x;
+		geom->lower_trough_rect.p0.y = geom->thumb_rect.p1.y;
+		geom->lower_trough_rect.p1 = geom->trough_rect.p1;
 
 		/* Down button */
 		geom->down_btn_rect.p0.x = orect.p0.x;
-		geom->down_btn_rect.p0.y = geom->through_rect.p1.y;
+		geom->down_btn_rect.p0.y = geom->trough_rect.p1.y;
 		geom->down_btn_rect.p1.x = orect.p1.x;
 		geom->down_btn_rect.p1.y = orect.p1.y;
@@ -732,14 +732,14 @@
 }
 
-/** Press down scrollbar up through.
- *
- * @param scrollbar Scrollbar
- */
-void ui_scrollbar_up_through_press(ui_scrollbar_t *scrollbar)
+/** Press down scrollbar upper trough.
+ *
+ * @param scrollbar Scrollbar
+ */
+void ui_scrollbar_upper_trough_press(ui_scrollbar_t *scrollbar)
 {
 	ui_clickmatic_t *clickmatic = ui_get_clickmatic(scrollbar->ui);
 
-	scrollbar->up_through_held = true;
-	scrollbar->up_through_inside = true;
+	scrollbar->upper_trough_held = true;
+	scrollbar->upper_trough_inside = true;
 
 	ui_clickmatic_set_cb(clickmatic, &ui_scrollbar_clickmatic_page_up_cb,
@@ -748,14 +748,14 @@
 }
 
-/** Press down scrollbar down through.
- *
- * @param scrollbar Scrollbar
- */
-void ui_scrollbar_down_through_press(ui_scrollbar_t *scrollbar)
+/** Press down scrollbar lower trough.
+ *
+ * @param scrollbar Scrollbar
+ */
+void ui_scrollbar_lower_trough_press(ui_scrollbar_t *scrollbar)
 {
 	ui_clickmatic_t *clickmatic = ui_get_clickmatic(scrollbar->ui);
 
-	scrollbar->down_through_held = true;
-	scrollbar->down_through_inside = true;
+	scrollbar->lower_trough_held = true;
+	scrollbar->lower_trough_inside = true;
 
 	ui_clickmatic_set_cb(clickmatic, &ui_scrollbar_clickmatic_page_down_cb,
@@ -778,11 +778,11 @@
 	}
 
-	if (scrollbar->up_through_held || scrollbar->down_through_held) {
+	if (scrollbar->upper_trough_held || scrollbar->lower_trough_held) {
 		clickmatic = ui_get_clickmatic(scrollbar->ui);
 		ui_clickmatic_release(clickmatic);
 		ui_clickmatic_set_cb(clickmatic, NULL, NULL);
 
-		scrollbar->up_through_held = false;
-		scrollbar->down_through_held = false;
+		scrollbar->upper_trough_held = false;
+		scrollbar->lower_trough_held = false;
 		(void) ui_scrollbar_paint(scrollbar);
 	}
@@ -791,10 +791,10 @@
 /** Update state of scrollbar throuhgs.
  *
- * Update state of scrollbar throughs after mouse cursor or thumb has moved.
+ * Update state of scrollbar troughs after mouse cursor or thumb has moved.
  *
  * @param scrollbar Scrollbar
  * @param pos Mouse cursor position
  */
-void ui_scrollbar_throughs_update(ui_scrollbar_t *scrollbar, gfx_coord2_t *pos)
+void ui_scrollbar_troughs_update(ui_scrollbar_t *scrollbar, gfx_coord2_t *pos)
 {
 	ui_scrollbar_geom_t geom;
@@ -804,20 +804,20 @@
 	ui_scrollbar_get_geom(scrollbar, &geom);
 
-	inside_up = gfx_pix_inside_rect(pos, &geom.up_through_rect);
-	inside_down = gfx_pix_inside_rect(pos, &geom.down_through_rect);
-
-	if (inside_up && !scrollbar->up_through_inside) {
-		scrollbar->up_through_inside = true;
+	inside_up = gfx_pix_inside_rect(pos, &geom.upper_trough_rect);
+	inside_down = gfx_pix_inside_rect(pos, &geom.lower_trough_rect);
+
+	if (inside_up && !scrollbar->upper_trough_inside) {
+		scrollbar->upper_trough_inside = true;
 		(void) ui_scrollbar_paint(scrollbar);
-	} else if (!inside_up && scrollbar->up_through_inside) {
-		scrollbar->up_through_inside = false;
+	} else if (!inside_up && scrollbar->upper_trough_inside) {
+		scrollbar->upper_trough_inside = false;
 		(void) ui_scrollbar_paint(scrollbar);
 	}
 
-	if (inside_down && !scrollbar->down_through_inside) {
-		scrollbar->down_through_inside = true;
+	if (inside_down && !scrollbar->lower_trough_inside) {
+		scrollbar->lower_trough_inside = true;
 		(void) ui_scrollbar_paint(scrollbar);
-	} else if (!inside_down && scrollbar->down_through_inside) {
-		scrollbar->down_through_inside = false;
+	} else if (!inside_down && scrollbar->lower_trough_inside) {
+		scrollbar->lower_trough_inside = false;
 		(void) ui_scrollbar_paint(scrollbar);
 	}
@@ -843,5 +843,5 @@
 	}
 
-	ui_scrollbar_throughs_update(scrollbar, pos);
+	ui_scrollbar_troughs_update(scrollbar, pos);
 }
 
@@ -866,5 +866,5 @@
 }
 
-/** Scrollbar up through was pressed.
+/** Scrollbar upper trough was pressed.
  *
  * @param scrollbar Scrollbar
@@ -876,5 +876,5 @@
 }
 
-/** Scrollbar down through was pressed.
+/** Scrollbar lower trough was pressed.
  *
  * @param scrollbar Scrollbar
@@ -927,16 +927,16 @@
 			return ui_claimed;
 		}
-		if (gfx_pix_inside_rect(&pos, &geom.up_through_rect)) {
-			ui_scrollbar_up_through_press(scrollbar);
+		if (gfx_pix_inside_rect(&pos, &geom.upper_trough_rect)) {
+			ui_scrollbar_upper_trough_press(scrollbar);
 			return ui_claimed;
 		}
-		if (gfx_pix_inside_rect(&pos, &geom.down_through_rect)) {
-			ui_scrollbar_down_through_press(scrollbar);
+		if (gfx_pix_inside_rect(&pos, &geom.lower_trough_rect)) {
+			ui_scrollbar_lower_trough_press(scrollbar);
 			return ui_claimed;
 		}
 		break;
 	case POS_RELEASE:
-		if (scrollbar->thumb_held || scrollbar->up_through_held ||
-		    scrollbar->down_through_held) {
+		if (scrollbar->thumb_held || scrollbar->upper_trough_held ||
+		    scrollbar->lower_trough_held) {
 			ui_scrollbar_release(scrollbar, &pos);
 			return ui_claimed;
@@ -1118,5 +1118,5 @@
 }
 
-/** Scrollbar clickmatic up through click event.
+/** Scrollbar clickmatic upper trough click event.
  *
  * @param clickmatic Clickmatic
@@ -1127,9 +1127,9 @@
 	ui_scrollbar_t *scrollbar = (ui_scrollbar_t *)arg;
 
-	if (scrollbar->up_through_inside)
+	if (scrollbar->upper_trough_inside)
 		ui_scrollbar_page_up(scrollbar);
 }
 
-/** Scrollbar clickmatic down through click event.
+/** Scrollbar clickmatic lower trough click event.
  *
  * @param clickmatic Clickmatic
@@ -1140,5 +1140,5 @@
 	ui_scrollbar_t *scrollbar = (ui_scrollbar_t *)arg;
 
-	if (scrollbar->down_through_inside)
+	if (scrollbar->lower_trough_inside)
 		ui_scrollbar_page_down(scrollbar);
 }
Index: uspace/lib/ui/test/list.c
===================================================================
--- uspace/lib/ui/test/list.c	(revision 56a3c29e88b204aab857b6e159ccf9e553cf0c09)
+++ uspace/lib/ui/test/list.c	(revision 4f6368c9f43c5e184ce86a446688b4311b0d63f1)
@@ -1039,4 +1039,47 @@
 }
 
+/** ui_list_entry_set_caption() sets entry captino */
+PCUT_TEST(entry_set_caption)
+{
+	ui_t *ui;
+	ui_window_t *window;
+	ui_wnd_params_t params;
+	ui_list_t *list;
+	ui_list_entry_attr_t attr;
+	ui_list_entry_t *entry;
+	errno_t rc;
+
+	rc = ui_create_disp(NULL, &ui);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	ui_wnd_params_init(&params);
+	params.caption = "Test";
+
+	rc = ui_window_create(ui, &params, &window);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = ui_list_create(window, true, &list);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	ui_list_entry_attr_init(&attr);
+
+	/* Append entry and get pointer to it */
+	attr.caption = "a";
+	attr.arg = (void *)1;
+	entry = NULL;
+	rc = ui_list_entry_append(list, &attr, &entry);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_NOT_NULL(entry);
+
+	/* Change caption */
+	rc = ui_list_entry_set_caption(entry, "b");
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_STR_EQUALS("b", entry->caption);
+
+	ui_list_destroy(list);
+	ui_window_destroy(window);
+	ui_destroy(ui);
+}
+
 /** ui_list_entries_cnt() returns the number of entries */
 PCUT_TEST(entries_cnt)
Index: uspace/lib/ui/test/scrollbar.c
===================================================================
--- uspace/lib/ui/test/scrollbar.c	(revision 56a3c29e88b204aab857b6e159ccf9e553cf0c09)
+++ uspace/lib/ui/test/scrollbar.c	(revision 4f6368c9f43c5e184ce86a446688b4311b0d63f1)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2022 Jiri Svoboda
+ * Copyright (c) 2023 Jiri Svoboda
  * All rights reserved.
  *
@@ -284,6 +284,6 @@
 }
 
-/** ui_scrollbar_through_length() gives correct scrollbar through length */
-PCUT_TEST(through_length)
+/** ui_scrollbar_trough_length() gives correct scrollbar trough length */
+PCUT_TEST(trough_length)
 {
 	ui_t *ui = NULL;
@@ -316,5 +316,5 @@
 	ui_scrollbar_set_rect(scrollbar, &rect);
 
-	length = ui_scrollbar_through_length(scrollbar);
+	length = ui_scrollbar_trough_length(scrollbar);
 
 	/* Total length minus buttons */
@@ -620,6 +620,6 @@
 }
 
-/** Press and release up through */
-PCUT_TEST(up_through_press_release)
+/** Press and release upper trough */
+PCUT_TEST(upper_trough_press_release)
 {
 	ui_t *ui = NULL;
@@ -654,8 +654,8 @@
 	ui_scrollbar_set_cb(scrollbar, &test_scrollbar_cb, &resp);
 
-	PCUT_ASSERT_FALSE(scrollbar->up_through_held);
-
-	ui_scrollbar_up_through_press(scrollbar);
-	PCUT_ASSERT_TRUE(scrollbar->up_through_held);
+	PCUT_ASSERT_FALSE(scrollbar->upper_trough_held);
+
+	ui_scrollbar_upper_trough_press(scrollbar);
+	PCUT_ASSERT_TRUE(scrollbar->upper_trough_held);
 	PCUT_ASSERT_TRUE(resp.page_up);
 
@@ -665,13 +665,13 @@
 
 	ui_scrollbar_release(scrollbar, &pos);
-	PCUT_ASSERT_FALSE(scrollbar->up_through_held);
-
-	ui_scrollbar_destroy(scrollbar);
-	ui_window_destroy(window);
-	ui_destroy(ui);
-}
-
-/** Press and release down through */
-PCUT_TEST(down_through_press_release)
+	PCUT_ASSERT_FALSE(scrollbar->upper_trough_held);
+
+	ui_scrollbar_destroy(scrollbar);
+	ui_window_destroy(window);
+	ui_destroy(ui);
+}
+
+/** Press and release lower trough */
+PCUT_TEST(lower_trough_press_release)
 {
 	ui_t *ui = NULL;
@@ -706,8 +706,8 @@
 	ui_scrollbar_set_cb(scrollbar, &test_scrollbar_cb, &resp);
 
-	PCUT_ASSERT_FALSE(scrollbar->down_through_held);
-
-	ui_scrollbar_down_through_press(scrollbar);
-	PCUT_ASSERT_TRUE(scrollbar->down_through_held);
+	PCUT_ASSERT_FALSE(scrollbar->lower_trough_held);
+
+	ui_scrollbar_lower_trough_press(scrollbar);
+	PCUT_ASSERT_TRUE(scrollbar->lower_trough_held);
 	PCUT_ASSERT_TRUE(resp.page_down);
 
@@ -717,13 +717,13 @@
 
 	ui_scrollbar_release(scrollbar, &pos);
-	PCUT_ASSERT_FALSE(scrollbar->down_through_held);
-
-	ui_scrollbar_destroy(scrollbar);
-	ui_window_destroy(window);
-	ui_destroy(ui);
-}
-
-/** Updating state of throughs when cursor or thumb moves */
-PCUT_TEST(throughs_update)
+	PCUT_ASSERT_FALSE(scrollbar->lower_trough_held);
+
+	ui_scrollbar_destroy(scrollbar);
+	ui_window_destroy(window);
+	ui_destroy(ui);
+}
+
+/** Updating state of troughs when cursor or thumb moves */
+PCUT_TEST(troughs_update)
 {
 	ui_t *ui = NULL;
@@ -754,11 +754,11 @@
 	ui_scrollbar_set_rect(scrollbar, &rect);
 
-	PCUT_ASSERT_FALSE(scrollbar->down_through_inside);
+	PCUT_ASSERT_FALSE(scrollbar->lower_trough_inside);
 
 	pos.x = 60;
 	pos.y = 22;
 
-	ui_scrollbar_throughs_update(scrollbar, &pos);
-	PCUT_ASSERT_TRUE(scrollbar->down_through_inside);
+	ui_scrollbar_troughs_update(scrollbar, &pos);
+	PCUT_ASSERT_TRUE(scrollbar->lower_trough_inside);
 
 	ui_scrollbar_destroy(scrollbar);
@@ -1082,6 +1082,6 @@
 }
 
-/** ui_scrollbar_pos_event() detects up through press/release */
-PCUT_TEST(pos_event_press_release_up_through)
+/** ui_scrollbar_pos_event() detects upper trough press/release */
+PCUT_TEST(pos_event_press_release_upper_trough)
 {
 	ui_t *ui = NULL;
@@ -1107,5 +1107,5 @@
 	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
 
-	PCUT_ASSERT_FALSE(scrollbar->up_through_held);
+	PCUT_ASSERT_FALSE(scrollbar->upper_trough_held);
 
 	rect.p0.x = 20;
@@ -1115,21 +1115,21 @@
 	ui_scrollbar_set_rect(scrollbar, &rect);
 
-	/* Need to move thumb so that up through can be accessed */
+	/* Need to move thumb so that upper trough can be accessed */
 	ui_scrollbar_set_pos(scrollbar, 42);
 
-	/* Press inside up through is claimed and depresses it */
+	/* Press inside upper trough is claimed and depresses it */
 	event.type = POS_PRESS;
 	event.hpos = 50;
 	event.vpos = 20;
 	claim = ui_scrollbar_pos_event(scrollbar, &event);
-	PCUT_ASSERT_TRUE(scrollbar->up_through_held);
+	PCUT_ASSERT_TRUE(scrollbar->upper_trough_held);
 	PCUT_ASSERT_EQUALS(ui_claimed, claim);
 
-	/* Release outside (or anywhere) is claimed and relases up through */
+	/* Release outside (or anywhere) is claimed and relases upper trough */
 	event.type = POS_RELEASE;
 	event.hpos = 41;
 	event.vpos = 32;
 	claim = ui_scrollbar_pos_event(scrollbar, &event);
-	PCUT_ASSERT_FALSE(scrollbar->up_through_held);
+	PCUT_ASSERT_FALSE(scrollbar->upper_trough_held);
 	PCUT_ASSERT_EQUALS(ui_claimed, claim);
 
@@ -1139,6 +1139,6 @@
 }
 
-/** ui_scrollbar_pos_event() detects down through press/release */
-PCUT_TEST(pos_event_press_release_down_through)
+/** ui_scrollbar_pos_event() detects lower trough press/release */
+PCUT_TEST(pos_event_press_release_lower_trough)
 {
 	ui_t *ui = NULL;
@@ -1164,5 +1164,5 @@
 	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
 
-	PCUT_ASSERT_FALSE(scrollbar->up_through_held);
+	PCUT_ASSERT_FALSE(scrollbar->upper_trough_held);
 
 	rect.p0.x = 20;
@@ -1172,18 +1172,18 @@
 	ui_scrollbar_set_rect(scrollbar, &rect);
 
-	/* Press inside down through is claimed and depresses it */
+	/* Press inside lower trough is claimed and depresses it */
 	event.type = POS_PRESS;
 	event.hpos = 70;
 	event.vpos = 20;
 	claim = ui_scrollbar_pos_event(scrollbar, &event);
-	PCUT_ASSERT_TRUE(scrollbar->down_through_held);
+	PCUT_ASSERT_TRUE(scrollbar->lower_trough_held);
 	PCUT_ASSERT_EQUALS(ui_claimed, claim);
 
-	/* Release outside (or anywhere) is claimed and relases up through */
+	/* Release outside (or anywhere) is claimed and relases upper trough */
 	event.type = POS_RELEASE;
 	event.hpos = 41;
 	event.vpos = 32;
 	claim = ui_scrollbar_pos_event(scrollbar, &event);
-	PCUT_ASSERT_FALSE(scrollbar->down_through_held);
+	PCUT_ASSERT_FALSE(scrollbar->lower_trough_held);
 	PCUT_ASSERT_EQUALS(ui_claimed, claim);
 
Index: uspace/srv/clipboard/meson.build
===================================================================
--- uspace/srv/clipboard/meson.build	(revision 56a3c29e88b204aab857b6e159ccf9e553cf0c09)
+++ uspace/srv/clipboard/meson.build	(revision 4f6368c9f43c5e184ce86a446688b4311b0d63f1)
@@ -1,3 +1,4 @@
 #
+# Copyright (c) 2023 Jiri Svoboda
 # Copyright (c) 2005 Martin Decky
 # Copyright (c) 2007 Jakub Jermar
@@ -28,3 +29,4 @@
 #
 
+deps = [ 'clipboard' ]
 src = files('clipboard.c')
Index: uspace/srv/hid/console/console.c
===================================================================
--- uspace/srv/hid/console/console.c	(revision 56a3c29e88b204aab857b6e159ccf9e553cf0c09)
+++ uspace/srv/hid/console/console.c	(revision 4f6368c9f43c5e184ce86a446688b4311b0d63f1)
@@ -37,4 +37,5 @@
 #include <stdio.h>
 #include <adt/prodcons.h>
+#include <io/console.h>
 #include <io/input.h>
 #include <ipc/vfs.h>
Index: uspace/srv/hid/console/meson.build
===================================================================
--- uspace/srv/hid/console/meson.build	(revision 56a3c29e88b204aab857b6e159ccf9e553cf0c09)
+++ uspace/srv/hid/console/meson.build	(revision 4f6368c9f43c5e184ce86a446688b4311b0d63f1)
@@ -28,3 +28,4 @@
 #
 
+deps = [ 'console', 'input', 'output' ]
 src = files('console.c')
Index: uspace/srv/hid/display/meson.build
===================================================================
--- uspace/srv/hid/display/meson.build	(revision 56a3c29e88b204aab857b6e159ccf9e553cf0c09)
+++ uspace/srv/hid/display/meson.build	(revision 4f6368c9f43c5e184ce86a446688b4311b0d63f1)
@@ -27,5 +27,5 @@
 #
 
-deps = [ 'ipcgfx', 'memgfx', 'display', 'ddev', 'dispcfg', 'wndmgt' ]
+deps = [ 'ipcgfx', 'memgfx', 'display', 'ddev', 'dispcfg', 'wndmgt', 'input' ]
 
 src = files(
Index: uspace/srv/hid/input/meson.build
===================================================================
--- uspace/srv/hid/input/meson.build	(revision 56a3c29e88b204aab857b6e159ccf9e553cf0c09)
+++ uspace/srv/hid/input/meson.build	(revision 4f6368c9f43c5e184ce86a446688b4311b0d63f1)
@@ -28,5 +28,5 @@
 #
 
-deps = [ 'drv' ]
+deps = [ 'drv', 'console', 'input' ]
 src = files(
 	'layout/cz.c',
Index: uspace/srv/hid/isdv4_tablet/meson.build
===================================================================
--- uspace/srv/hid/isdv4_tablet/meson.build	(revision 56a3c29e88b204aab857b6e159ccf9e553cf0c09)
+++ uspace/srv/hid/isdv4_tablet/meson.build	(revision 4f6368c9f43c5e184ce86a446688b4311b0d63f1)
@@ -27,4 +27,4 @@
 #
 
-deps = [ 'drv' ]
+deps = [ 'drv', 'input' ]
 src = files('main.c', 'isdv4.c')
Index: uspace/srv/hid/output/meson.build
===================================================================
--- uspace/srv/hid/output/meson.build	(revision 56a3c29e88b204aab857b6e159ccf9e553cf0c09)
+++ uspace/srv/hid/output/meson.build	(revision 4f6368c9f43c5e184ce86a446688b4311b0d63f1)
@@ -28,5 +28,5 @@
 #
 
-deps = [ 'codepage', 'drv', 'fbfont', 'pixconv', 'ddev' ]
+deps = [ 'codepage', 'console', 'drv', 'fbfont', 'pixconv', 'ddev', 'output' ]
 src = files(
 	'ctl/serial.c',
Index: uspace/srv/hid/remcons/meson.build
===================================================================
--- uspace/srv/hid/remcons/meson.build	(revision 56a3c29e88b204aab857b6e159ccf9e553cf0c09)
+++ uspace/srv/hid/remcons/meson.build	(revision 4f6368c9f43c5e184ce86a446688b4311b0d63f1)
@@ -28,4 +28,4 @@
 #
 
-deps = [ 'inet' ]
+deps = [ 'inet', 'console' ]
 src = files('remcons.c', 'user.c')
Index: uspace/srv/hid/s3c24xx_ts/meson.build
===================================================================
--- uspace/srv/hid/s3c24xx_ts/meson.build	(revision 56a3c29e88b204aab857b6e159ccf9e553cf0c09)
+++ uspace/srv/hid/s3c24xx_ts/meson.build	(revision 4f6368c9f43c5e184ce86a446688b4311b0d63f1)
@@ -27,3 +27,4 @@
 #
 
+deps = [ 'input' ]
 src = files('s3c24xx_ts.c')
Index: uspace/srv/hid/s3c24xx_ts/s3c24xx_ts.c
===================================================================
--- uspace/srv/hid/s3c24xx_ts/s3c24xx_ts.c	(revision 56a3c29e88b204aab857b6e159ccf9e553cf0c09)
+++ uspace/srv/hid/s3c24xx_ts/s3c24xx_ts.c	(revision 4f6368c9f43c5e184ce86a446688b4311b0d63f1)
@@ -39,5 +39,4 @@
 #include <ddi.h>
 #include <loc.h>
-#include <io/console.h>
 #include <vfs/vfs.h>
 #include <ipc/mouseev.h>
Index: uspace/srv/taskmon/meson.build
===================================================================
--- uspace/srv/taskmon/meson.build	(revision 56a3c29e88b204aab857b6e159ccf9e553cf0c09)
+++ uspace/srv/taskmon/meson.build	(revision 4f6368c9f43c5e184ce86a446688b4311b0d63f1)
@@ -1,4 +1,4 @@
 #
-# Copyright (c) 2010 Jiri Svoboda
+# Copyright (c) 2023 Jiri Svoboda
 # All rights reserved.
 #
@@ -27,3 +27,4 @@
 #
 
+deps = [ 'corecfg' ]
 src = files('taskmon.c')
Index: uspace/srv/test/ipc-test/meson.build
===================================================================
--- uspace/srv/test/ipc-test/meson.build	(revision 56a3c29e88b204aab857b6e159ccf9e553cf0c09)
+++ uspace/srv/test/ipc-test/meson.build	(revision 4f6368c9f43c5e184ce86a446688b4311b0d63f1)
@@ -1,4 +1,4 @@
 #
-# Copyright (c) 2018 Jiri Svoboda
+# Copyright (c) 2023 Jiri Svoboda
 # All rights reserved.
 #
@@ -27,3 +27,4 @@
 #
 
+deps = [ 'ipctest' ]
 src = files('main.c')
